		list	p=10F206           ; list directive to define processor
        #include	<p10F206.inc>

		RADIX	dec

#define	uno	 B'00000110'
#define	cero B'00000001'


; Pulse lenght in tenths of a second
#define pulseLenght 10
; Sleep lenght in halves of a second
#define noni	1
; Frequency limits in Hz
#define fmin 20000
#define fmax 50000

clockrate equ 4000000         			; define clock rate here
delayconst1	equ	(clockrate/(8*256*8))	; get 1/2 second
delayconst2	equ	(noni)

freqconstm	equ 24-(((clockrate/(4*fmin))-13)/2)	; get #iterations per cycle (24-cycles)
freqconstM	equ 24-(((clockrate/(4*fmax))-13)/2)
cyclesm		equ	(fmin*pulseLenght)/2560 		; get #cycle_iterations for 0,1 sec
cyclesM		equ (fmax*pulseLenght)/2560 
cyclesK		equ (cyclesM-cyclesm)/(freqconstM-freqconstm)

 
vars	UDATA
delay	RES 3
freq	RES 1
cycles	RES 3

master	CODE	0
start
		movwf OSCCAL 			; Calibrate
        clrf GPIO
        movlw B'01000001'
        movwf CMCON0			; Select GP2
        movlw B'11001111'
		option					; keep GP2
        movlw  B'00001000'     	; GP0,GP1,GP2 = output
		tris GPIO
		clrf cycles+2			; 256 iterations
main
		movlw freqconstm
		movwf freq
		movlw cyclesm
		movwf cycles
		movwf cycles+1
cycloop	movlw uno					; 1
        movwf GPIO		
		movf freq,W
		addwf PCL,f					; 5 + nop's
		fill (nop),24					; 24 nop's
		movlw cero
        movwf GPIO		
		movf freq,W
		addwf PCL,f					; 10 + 2*nop's
		fill (nop),24					; 24 nop's
		decfsz cycles+2,f			; perform 256 cycles
		goto cycloop				; 13 + 2*freq
		decfsz cycles+1,f			; times 'cycles', to get a pulse
		goto cycloop
		clrf GPIO				; no voltage on outputs
		call Sleepdelay			; and then sleep for 'noni' half seconds
		incf freq,f				; Increment frequency
		movlw freqconstM+1
		subwf freq,w
		btfsc STATUS,Z			; Check if we've exceeded fmax
		goto main				; and restart cycle
		movlw cyclesK			; Increment #cycles to do
		addwf cycles,f
		goto cycloop


Sleepdelay						; Delay for noni halves
		movlw delayconst2
		goto l0
HSdelay	movlw 1					; Delay half a second
l0		movwf delay+2
		clrf delay
l2		movlw delayconst1
		movwf delay+1
l1		goto l1a
l1a		goto l1b
l1b		nop
		decfsz delay,f
		goto l1
		decfsz delay+1,f
		goto l1
		decfsz delay+2,f
		goto l2
		retlw 0

		end
